(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15683,        468]
NotebookOptionsPosition[     13117,        403]
NotebookOutlinePosition[     13470,        419]
CellTagsIndexPosition[     13427,        416]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

(* Copyright (C) Khalil Ghorbal 2013-2015 *)
(* email. khalil.ghorbal@gmail.com *)
(* This package is released under GPL license. Please read the COPYRIGHT file \
*)
\
\>", "Text",
 CellChangeTimes->{{3.714299893952449*^9, 
  3.714299921977799*^9}},ExpressionUUID->"1574ed42-52de-4734-a308-\
573f1c7aae4a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"GenInvVar", "[", 
    RowBox[{
     RowBox[{"Vector", " ", "Field"}], ",", " ", 
     RowBox[{"List", " ", "of", " ", "variables"}], ",", " ", 
     RowBox[{"Degree", " ", "of", " ", "the", " ", "template"}], ",", " ", 
     RowBox[{"Order", 
      RowBox[{"(", "N", ")"}]}]}], "]"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", " ", "instance"}], ",", " ", 
    RowBox[{
     RowBox[{"if", " ", "the", " ", "vector", " ", "field", " ", "is", " ", 
      RowBox[{"x1", "'"}]}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x2"}], " ", "and", " ", 
       RowBox[{"x2", "'"}]}], "=", 
      RowBox[{
      "x1", " ", "and", " ", "we", " ", "are", " ", "looking", " ", "for", 
       " ", "a", " ", "\[IndentingNewLine]", "Darboux", " ", "polynomial", 
       " ", 
       RowBox[{"(", 
        RowBox[{"N", "=", "1"}], ")"}], " ", "of", " ", "degree", " ", 
       "1"}]}]}], ",", " ", 
    RowBox[{
    "then", " ", "the", " ", "procedure", " ", "call", " ", "is", " ", "as", 
     " ", 
     RowBox[{"follows", ":"}]}]}], " ", "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"GenInvVar", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "x2"}], ",", "x1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2"}], "}"}], ",", "1", ",", "1"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.714299649251781*^9, 3.7142996493497477`*^9}, {
  3.714299681807878*^9, 
  3.714299899573183*^9}},ExpressionUUID->"916e20a8-42ad-4da9-a7c0-\
47e241f75a35"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"x0", " ", "\[Alpha]1"}], "+", 
  RowBox[{"x1", " ", "\[Alpha]2"}], "+", 
  RowBox[{"x2", " ", "\[Alpha]3"}]}]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.7142999371764297`*^9},ExpressionUUID->"616c1eaa-53a2-4c1a-9e32-\
86dc45cb83e6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[Alpha]3"}], "+", 
    RowBox[{"\[Alpha]2", " ", "\[Beta]01"}]}], ",", 
   RowBox[{"\[Alpha]2", "+", 
    RowBox[{"\[Alpha]3", " ", "\[Beta]01"}]}], ",", 
   RowBox[{"\[Alpha]1", " ", "\[Beta]01"}]}], "}"}]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.714299937183156*^9},ExpressionUUID->"f7b266c0-a333-44ab-812a-\
3bfb1a8b24e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], "\[InvisibleSpace]", "\<\" with \"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\" symbols\"\>"}],
  SequenceForm[{3, 3}, " with ", 1, " symbols"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.714299937192361*^9},ExpressionUUID->"f33b1ca6-f9c5-4cb3-b7cc-\
dcee62db8cb6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"# of objects: \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\". Path lengths \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}], 
   "\[InvisibleSpace]", "\<\". Memory used (Gb): \"\>", "\[InvisibleSpace]", 
   "0.12042651325464249`"}],
  SequenceForm[
  "# of objects: ", 1, ". Path lengths ", {0}, ". Memory used (Gb): ", 
   0.12042651325464249`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.714299937196047*^9},ExpressionUUID->"bf213a1c-f1c5-4825-9ea5-\
a2df0e69e17c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"# of objects: \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\". Path lengths \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}], 
   "\[InvisibleSpace]", "\<\". Memory used (Gb): \"\>", "\[InvisibleSpace]", 
   "0.12042645364999771`"}],
  SequenceForm[
  "# of objects: ", 1, ". Path lengths ", {1}, ". Memory used (Gb): ", 
   0.12042645364999771`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.7142999371998053`*^9},ExpressionUUID->"821e9219-1dd1-49cb-adfd-\
58368de3de0c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "\[Gamma]1", "}"}], "}"}]], "Print",
 CellChangeTimes->{{3.7142996377872667`*^9, 3.714299649814178*^9}, 
   3.714299937203545*^9},ExpressionUUID->"ac690eb5-d591-43c3-a63b-\
4a8ebcc82dac"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", "\<\"No Non-Trivial Found\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.714299638692389*^9, 3.714299649942131*^9}, 
   3.7142999372071857`*^9},ExpressionUUID->"37ce46c8-3501-4a47-ad8e-\
97d34e6fe7f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"However", ",", " ", 
    RowBox[{
    "if", " ", "for", " ", "a", " ", "template", " ", "of", " ", "degree", 
     " ", "2"}], ",", " ", 
    RowBox[{"then", " ", "one", " ", "finds"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"GenInvVar", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "x2"}], ",", "x1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2"}], "}"}], ",", "2", ",", "1"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.71429994078594*^9, 
  3.714299993592746*^9}},ExpressionUUID->"249a9d19-5188-4c51-92f8-\
a35616497191"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["x0", "2"], " ", "\[Alpha]1"}], "+", 
  RowBox[{"x0", " ", "x1", " ", "\[Alpha]2"}], "+", 
  RowBox[{"x0", " ", "x2", " ", "\[Alpha]3"}], "+", 
  RowBox[{
   SuperscriptBox["x1", "2"], " ", "\[Alpha]4"}], "+", 
  RowBox[{"x1", " ", "x2", " ", "\[Alpha]5"}], "+", 
  RowBox[{
   SuperscriptBox["x2", "2"], " ", "\[Alpha]6"}]}]], "Print",
 CellChangeTimes->{
  3.714299993948984*^9},ExpressionUUID->"f12550c1-515e-4e9f-9b03-\
05f8619b5d00"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[Alpha]5"}], "+", 
    RowBox[{"\[Alpha]4", " ", "\[Beta]01"}]}], ",", 
   RowBox[{
    RowBox[{"2", " ", "\[Alpha]4"}], "-", 
    RowBox[{"2", " ", "\[Alpha]6"}], "+", 
    RowBox[{"\[Alpha]5", " ", "\[Beta]01"}]}], ",", 
   RowBox[{
    RowBox[{"-", "\[Alpha]3"}], "+", 
    RowBox[{"\[Alpha]2", " ", "\[Beta]01"}]}], ",", 
   RowBox[{"\[Alpha]5", "+", 
    RowBox[{"\[Alpha]6", " ", "\[Beta]01"}]}], ",", 
   RowBox[{"\[Alpha]2", "+", 
    RowBox[{"\[Alpha]3", " ", "\[Beta]01"}]}], ",", 
   RowBox[{"\[Alpha]1", " ", "\[Beta]01"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.714299993952937*^9},ExpressionUUID->"433bd2af-bfd0-4e3f-82c2-\
8d3780564a1a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}], "\[InvisibleSpace]", "\<\" with \"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\" symbols\"\>"}],
  SequenceForm[{6, 6}, " with ", 1, " symbols"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7142999939597397`*^9},ExpressionUUID->"409202a7-5523-456d-a1b6-\
315421399617"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"# of objects: \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\". Path lengths \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}], 
   "\[InvisibleSpace]", "\<\". Memory used (Gb): \"\>", "\[InvisibleSpace]", 
   "0.12044702470302582`"}],
  SequenceForm[
  "# of objects: ", 1, ". Path lengths ", {0}, ". Memory used (Gb): ", 
   0.12044702470302582`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.71429999396348*^9},ExpressionUUID->"484bba4c-16f2-45f4-857d-44ca415094ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"# of objects: \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\". Path lengths \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}], 
   "\[InvisibleSpace]", "\<\". Memory used (Gb): \"\>", "\[InvisibleSpace]", 
   "0.12044381350278854`"}],
  SequenceForm[
  "# of objects: ", 1, ". Path lengths ", {1}, ". Memory used (Gb): ", 
   0.12044381350278854`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7142999939674997`*^9},ExpressionUUID->"2b86dccf-dc0d-4d83-b534-\
e8833a907a1b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["x1", "2"]}], " ", "\[Gamma]1"}], "-", 
    RowBox[{
     SuperscriptBox["x2", "2"], " ", "\[Gamma]1"}], "-", "\[Gamma]2"}], "}"}],
   "}"}]], "Print",
 CellChangeTimes->{
  3.714299993971403*^9},ExpressionUUID->"c234566b-d068-4461-8086-\
69aac788fee4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"M :: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["x1", "2"]}], "-", 
         SuperscriptBox["x2", "2"]}], 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     SparseArray[
      Automatic, {1, 2}, 0, {
       1, {{0, 2}, {{1}, {
         2}}}, {-$CellContext`x1^2 - $CellContext`x2^2, -1}}]]]]}],
  SequenceForm["M :: ", 
   MatrixForm[
   SparseArray[
    Automatic, {1, 2}, 0, {
     1, {{0, 2}, {{1}, {2}}}, {-$CellContext`x1^2 - $CellContext`x2^2, -1}}]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7142999939754963`*^9},ExpressionUUID->"bf51fd9d-847a-488c-9358-\
cab07b86557e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"init \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}]}],
  SequenceForm["init ", {0}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.714299993980541*^9},ExpressionUUID->"bda1af1b-8c2c-4e3f-8a21-\
dd58439d5179"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["x1", "2"]}], "-", 
       SuperscriptBox["x2", "2"]}], 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   SparseArray[
    Automatic, {1, 2}, 0, {
     1, {{0, 2}, {{1}, {
       2}}}, {-$CellContext`x1^2 - $CellContext`x2^2, -1}}]]]]], "Print",
 CellChangeTimes->{
  3.714299993984453*^9},ExpressionUUID->"21d687b8-3e6a-4de2-a3db-\
e38e9458f5f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"v0 :: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["x10", "2"]}], "-", 
       SuperscriptBox["x20", "2"]}]}], "}"}], "}"}]}],
  SequenceForm["v0 :: ", {{1, -$CellContext`x10^2 - $CellContext`x20^2}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7142999939884243`*^9},ExpressionUUID->"d2a45d1f-b84a-480f-99b8-\
e3c056dbc036"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["x1", "2"]}], "+", 
    SuperscriptBox["x10", "2"], "-", 
    SuperscriptBox["x2", "2"], "+", 
    SuperscriptBox["x20", "2"]}], "\[Equal]", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7142999939922447`*^9},ExpressionUUID->"d8d0629e-7ecb-4803-8a68-\
f65ce5b22483"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"which", " ", "means", " ", "that", " ", 
    RowBox[{"x1", "^", "2"}]}], "+", 
   RowBox[{
    RowBox[{"x2", "^", "2"}], " ", "is", " ", "an", " ", "invariant", " ", 
    "function", " ", 
    RowBox[{"(", 
     RowBox[{
     "x10", " ", "and", " ", "x20", " ", "denote", " ", "any", " ", "initial",
       " ", "condition"}], ")"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.714299996732924*^9, 
  3.714300048651247*^9}},ExpressionUUID->"565ff022-87c9-427f-b7c7-\
19f96985f72f"]
},
WindowSize->{912, 851},
WindowMargins->{{Automatic, 8}, {Automatic, 0}},
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 18, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 317, 10, 106, "Text", "ExpressionUUID" -> \
"1574ed42-52de-4734-a308-573f1c7aae4a"],
Cell[CellGroupData[{
Cell[900, 34, 1670, 44, 180, "Input", "ExpressionUUID" -> \
"916e20a8-42ad-4da9-a7c0-47e241f75a35"],
Cell[CellGroupData[{
Cell[2595, 82, 308, 7, 24, "Print", "ExpressionUUID" -> \
"616c1eaa-53a2-4c1a-9e32-86dc45cb83e6"],
Cell[2906, 91, 439, 11, 24, "Print", "ExpressionUUID" -> \
"f7b266c0-a333-44ab-812a-3bfb1a8b24e0"],
Cell[3348, 104, 439, 10, 24, "Print", "ExpressionUUID" -> \
"f33b1ca6-f9c5-4cb3-b7cc-dcee62db8cb6"],
Cell[3790, 116, 600, 13, 24, "Print", "ExpressionUUID" -> \
"bf213a1c-f1c5-4825-9ea5-a2df0e69e17c"],
Cell[4393, 131, 602, 13, 24, "Print", "ExpressionUUID" -> \
"821e9219-1dd1-49cb-adfd-58368de3de0c"],
Cell[4998, 146, 231, 5, 24, "Print", "ExpressionUUID" -> \
"ac690eb5-d591-43c3-a63b-4a8ebcc82dac"]
}, Open  ]],
Cell[5244, 154, 228, 4, 32, "Output", "ExpressionUUID" -> \
"37ce46c8-3501-4a47-ad8e-97d34e6fe7f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5509, 163, 636, 19, 54, "Input", "ExpressionUUID" -> \
"249a9d19-5188-4c51-92f8-a35616497191"],
Cell[CellGroupData[{
Cell[6170, 186, 491, 13, 25, "Print", "ExpressionUUID" -> \
"f12550c1-515e-4e9f-9b03-05f8619b5d00"],
Cell[6664, 201, 727, 20, 24, "Print", "ExpressionUUID" -> \
"433bd2af-bfd0-4e3f-82c2-8d3780564a1a"],
Cell[7394, 223, 392, 10, 24, "Print", "ExpressionUUID" -> \
"409202a7-5523-456d-a1b6-315421399617"],
Cell[7789, 235, 548, 12, 24, "Print", "ExpressionUUID" -> \
"484bba4c-16f2-45f4-857d-44ca415094ef"],
Cell[8340, 249, 553, 13, 24, "Print", "ExpressionUUID" -> \
"2b86dccf-dc0d-4d83-b534-e8833a907a1b"],
Cell[8896, 264, 363, 12, 27, "Print", "ExpressionUUID" -> \
"c234566b-d068-4461-8086-69aac788fee4"],
Cell[9262, 278, 1228, 36, 27, "Print", "ExpressionUUID" -> \
"bf51fd9d-847a-488c-9358-cab07b86557e"],
Cell[10493, 316, 274, 8, 24, "Print", "ExpressionUUID" -> \
"bda1af1b-8c2c-4e3f-8a21-dd58439d5179"],
Cell[10770, 326, 921, 28, 27, "Print", "ExpressionUUID" -> \
"21d687b8-3e6a-4de2-a3db-e38e9458f5f6"],
Cell[11694, 356, 486, 14, 27, "Print", "ExpressionUUID" -> \
"d2a45d1f-b84a-480f-99b8-e3c056dbc036"]
}, Open  ]],
Cell[12195, 373, 359, 11, 35, "Output", "ExpressionUUID" -> \
"d8d0629e-7ecb-4803-8a68-f65ce5b22483"]
}, Open  ]],
Cell[12569, 387, 544, 14, 32, "Input", "ExpressionUUID" -> \
"565ff022-87c9-427f-b7c7-19f96985f72f"]
}
]
*)

